import { Head, Length, Tail, TArray } from './Promoted/TArray';
import { Eq } from './Promoted/Eq';
import { Assert } from './Primitive/Assert';
export declare type TFunction = (...args: never) => unknown;
declare type ConstraintVariadicFunction<f extends TFunction> = Eq<Length<Parameters<f>>, number> extends true ? [never] : never;
export declare type Curried<f extends TFunction> = Length<Parameters<f>> extends 0 ? ReturnType<f> : (x: Head<Parameters<f>>) => Curried<(...args: Assert<Tail<Parameters<f>>, TArray>) => ReturnType<f>>;
export declare function curry<f extends TFunction, constraint extends ConstraintVariadicFunction<f>>(f: f): Length<Parameters<f>> extends 0 ? f : Curried<f>;
export {};
